package com.ozs.web.controller.shotschedule;

import com.ozs.system.service.ISysDictDataService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.UUID;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

/**
 * @author wyy
 * @subject
 * @creat 2023/5/6
 */
@Configuration
@EnableScheduling
@EnableAsync
@Slf4j
public class ShotExecutors {

   // private  static ScheduledExecutorService scheduledExecutorService = Executors.newScheduledThreadPool(5);
    @Autowired
    private ISysDictDataService dictDataService;
    @Autowired
    private TaskNormalService taskNormalService; //定时任务-没有报警摄像头
    @Autowired
    private TaskAlarmService taskAlarmService;//定时任务-报警摄像头

    /**
     * 处理非预警摄像头截图
     */
    @Async
    @Scheduled(fixedRate = 500)
    public void handleNormalPicture() {
        boolean shotSwitch = Boolean.parseBoolean(dictDataService.selectDictLabel("shot_switch", String.valueOf(0)));
        try {
            if (shotSwitch) {
                taskNormalService.getNormalPicture();
            }
        } catch (Exception e) {
            e.getMessage();
            log.error(e.getMessage());
        }
    }

    /**
     * 处理预警摄像头截图
     */
    @Async
    @Scheduled(fixedRate = 200)
    public void handleAlarmPicture() {
        boolean shotSwitch = Boolean.parseBoolean(dictDataService.selectDictLabel("shot_switch", String.valueOf(0)));
        try {
            if (shotSwitch) {
                taskAlarmService.getAlarmPicture();
            }
        } catch (Exception e) {
            e.getMessage();
            log.error(e.getMessage());
        }
    }
}
